
#include <cstdio>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

// extended template
#pragma comment(linker, "/STACK:36777216")

template <typename T> istream &operator>>(istream &, vector<T> &);
template <typename T> ostream &operator<<(ostream &, const vector<T> &);

void solve() {
  int t;
  cin >> t;
  for (int q = 0; q < t; q++) {
    string s;
    int k;
    cin >> s >> k;
    int n = s.size();
    vector<int> add(n);

    int ans = 0;
    int sum = 0;
    for (int i = 0; i < n - k + 1; i++) {
      int val = s[i] == '-' ? 0 : 1;
      sum += add[i];
      val += sum;

      if (val % 2 == 0) {
        ans++;
        add[i] += 1;
        sum += 1;
        if (i + k < n)
          add[i + k] += 1;
      }
    }

    bool fl = 1;
    for (int i = n - k + 1; i < n; i++) {
      int val = s[i] == '-' ? 0 : 1;
      sum += add[i];
      val += sum;

      if (val % 2 == 0)
        fl = 0;
    }

    cout << "Case #" << q + 1 << ": ";
    if (fl == 0)
      cout << "IMPOSSIBLE" << endl;
    else
      cout << ans << endl;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  // START
  // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
  freopen("A-small-attempt0.in", "r", stdin);
  freopen("output.txt", "w", stdout);
  solve();

  // END
  return 0;
}
/*******************************************
*******************************************/

template <typename T> istream &operator>>(istream &is, vector<T> &v) {
  for (int i = 0; i < v.size(); ++i)
    is >> v[i];
  return is;
}
template <typename T> ostream &operator<<(ostream &os, const vector<T> &v) {
  for (int i = 0; i < v.size(); ++i)
    os << v[i] << " ";
  return os;
}
