#include <algorithm>
#include <set>
#include <stdio.h>
#include <string.h>
#include <utility>
#include <vector>

using namespace std;
typedef long long ll;

typedef pair<ll, ll> Pll;
int N, M, tc;
ll r[150];
ll p[150][150];
set<Pll> cur[150];
Pll range[150][150];
struct event {
  ll n;
  ll x;
  ll y;
  ll t;
};

bool cmp(event e1, event e2) {
  if (e1.n == e2.n)
    return e1.t > e2.t;
  return e1.n < e2.n;
}
ll gcd(ll a, ll b) {
  if (b == 0)
    return a;
  return gcd(b, a % b);
}
struct fraction {
  ll x, y;
  fraction() {
    x = 0;
    y = 1;
  }
  fraction(ll _x, ll _y) {
    x = _x;
    y = _y;
    ll g = gcd(x, y);
    x = x / g;
    y = y / g;
  }

  ll ceil() { return (x + y - 1) / y; }
  ll floor() { return x / y; }

  fraction operator*(fraction a) {
    fraction res = fraction(a.x * x, a.y * y);
    return res;
  }
};

void solve2() {
  for (int i = 0; i < 150; i++)
    for (int j = 0; j < 150; j++)
      range[i][j] = {-1, -1};
  for (int i = 0; i < 150; i++)
    cur[i].clear();
  memset(p, 0, sizeof p);
  memset(r, 0, sizeof r);
  scanf("%d%d", &N, &M);
  for (int i = 1; i <= N; i++)
    scanf("%lld", r + i);
  for (int i = 1; i <= N; i++) {
    for (int j = 1; j <= M; j++)
      scanf("%lld", &p[i][j]);
  }

  ll ans = 0;

  vector<int> v;
  for (int i = 1; i <= M; i++)
    v.push_back(i);

  for (int i = 1; i <= N; i++) {
    for (int j = 1; j <= M; j++) {
      fraction nl, nr;
      nl = fraction(p[i][j], r[i]);
      nl = nl * fraction(10, 11);
      nr = fraction(p[i][j], r[i]);
      nr = nr * fraction(10, 9);

      ll nleft = nl.ceil();
      ll nright = nr.floor();
      if (nleft > nright)
        continue;
      range[i][j] = {nleft, nright};

      // 1 이면 들어오고 -1이면 나감
      // printf("[%lld,%lld]\n",nleft,nright);
    }
  }

  if (N == 1) {
    for (int j = 1; j <= M; j++) {
      if (range[1][j].first != -1 && range[1][j].second != -1)
        ans++;
    }
    printf("%lld\n", ans);
    return;
  }

  do {
    ll cnt = 0;
    for (int j = 1; j <= M; j++) {
      int jj = v[j - 1];
      if (range[1][j].first == -1 || range[1][j].second == -1)
        continue;
      if (range[2][jj].first == -1 || range[2][jj].second == -1)
        continue;
      ll curl = range[1][j].first;
      ll curr = range[1][j].second;
      curl = max(curl, range[2][jj].first);
      curr = min(curr, range[2][jj].second);
      if (curl <= curr)
        cnt++;
    }
    ans = max(cnt, ans);
  } while (next_permutation(v.begin(), v.end()));

  printf("%lld\n", ans);
}

int main(void) {
  freopen("output2.txt", "w", stdout);
  scanf("%d", &tc);
  for (int t = 1; t <= tc; t++) {
    printf("Case #%d: ", t);
    solve2();
  }
}
