// C++
#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;

typedef vector<int> vi;

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

bool tidy(vi &digits) {
  for (int i = 1; i < (int)(digits.size()); i++) {
    if (digits[i - 1] > digits[i])
      return false;
  }
  return true;
}

vi solve() {
  ll N;
  cin >> N;

  vi digits;
  while (N > 0) {
    int d = N % 10;
    digits.push_back(d);
    N /= 10;
  }
  reverse(((digits).begin()), ((digits).end()));

  if (tidy(digits))
    return digits;

  for (int i = 1; i < (int)(digits.size()); i++) {
    if (digits[i - 1] >= digits[i]) {
      if (digits[i - 1] > 1) {
        digits[i - 1]--;
        for (int j = i; j < (int)(digits.size()); j++)
          digits[j] = 9;
      }
      break;
    }
  }

  if (tidy(digits))
    return digits;

  vi decreased(digits.size() - 1, 9);
  return decreased;
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ": ";
    vi ans = solve();
    for (__typeof((ans).begin()) it = (ans).begin(); it != (ans).end(); it++)
      cout << *it;
    cout << endl;
  }
  return 0;
}
