#include <ext/alloc_traits.h>
#include <iostream>
#include <map>
#include <string>
#include <utility>
#include <vector>

using namespace std;

typedef pair<int, int> pii;

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

void solve() {
  int R, C;
  cin >> R >> C;

  vector<string> field(R);
  //    vector<pii> start;

  map<int, pii> pos;

  for (int i = 0; i < (int)(R); i++)
    cin >> field[i];

  for (int i = 0; i < (int)(R); i++) {
    for (int j = 0; j < (int)(C); j++) {
      if (field[i][j] != '?') {
        int code = field[i][j] - 'A';
        pos[code] = make_pair(i, j);
      }
    }
  }

  for (int r = 0; r < (int)(R); r++) {
    for (int c = 1; c < (int)(C); c++) {
      if (field[r][c] == '?')
        field[r][c] = field[r][c - 1];
    }
    for (int c = C - 2; c >= 0; c--) {
      if (field[r][c] == '?')
        field[r][c] = field[r][c + 1];
    }
  }

  for (int c = 0; c < (int)(C); c++) {
    for (int r = 1; r < (int)(R); r++) {
      if (field[r][c] == '?')
        field[r][c] = field[r - 1][c];
    }
    for (int r = R - 2; r >= 0; r--) {
      if (field[r][c] == '?')
        field[r][c] = field[r + 1][c];
    }
  }

  for (int r = 0; r < (int)(R); r++) {
    cout << field[r] << endl;
  }
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ":" << endl;
    solve();
  }
  return 0;
}
