#include <ext/alloc_traits.h>
#include <iostream>
#include <memory>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;

typedef vector<int> vi;
typedef vector<ll> vll;

typedef vector<long double> vd;
typedef vector<vd> vvd;

typedef pair<int, int> pii;

template <class T> bool chmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

void solve() {

  const ll INF = 1ll << 50;

  int N, Q;
  cin >> N >> Q;

  vector<pii> hou(N);
  for (int i = 0; i < (int)(N); i++) {
    cin >> hou[i].first >> hou[i].second;
  }

  vi d(N, 0);
  for (int i = 0; i < (int)(N); i++) {
    for (int j = 0; j < (int)(N); j++) {
      int t;
      cin >> t;
      if (i == j - 1) {
        d[i] = t;
      }
    }
  }

  for (int i = 0; i < (int)(Q); i++) {
    int s, e;
    cin >> s >> e;
  }

  //    cout << d << endl;

  vll acc(N, 0);
  for (int i = 1; i < (int)(N); i++) {
    acc[i] += d[i - 1] + acc[i - 1];
  }

  //    cout << acc << endl;

  vvd dp(N + 1, vd(N + 1, INF));
  dp[1][0] = (long double)d[0] / hou[0].second;
  for (int i = 0; i < (int)(N); i++) {
    for (int j = 0; j < (int)(i); j++) {
      if (dp[i][j] == INF)
        continue;

      //            cout << "run: "<< acc[i] - acc[j] << endl;
      int remd = hou[j].first - (acc[i] - acc[j]);
      //            cout << remd << endl;

      // not change
      if (remd > d[i]) {
        chmin(dp[i + 1][j], dp[i][j] + (long double)d[i] / hou[j].second);
      }
      // change
      chmin(dp[i + 1][i], dp[i][j] + (long double)d[i] / hou[i].second);
    }
  }

  long double ans = INF;
  for (int i = 0; i < (int)(N); i++) {
    chmin(ans, dp[N][i]);
  }

  cout << ans;
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ": ";
    solve();
    cout << endl;
  }
  return 0;
}
