// satyaki3794

#include <algorithm>
#include <iomanip>
#include <iostream>
#include <memory>
#include <queue>
#include <stdio.h>
#include <utility>

using namespace std;

const int N = 102;
int n, q;
double endurance[N], speed[N], adj[N][N], dist[N][N];

typedef pair<double, int> pdi;
void dijkstra(int src) {
  for (int i = 1; i <= n; i++)
    dist[src][i] = 1e15;
  priority_queue<pdi> pq;
  dist[src][src] = 0;
  pq.push(pdi(0, src));
  while (!pq.empty()) {

    int v = pq.top().second;
    double d = -pq.top().first;
    pq.pop();
    if (d > dist[src][v])
      continue;

    for (int vv = 1; vv <= n; vv++) {
      if (adj[v][vv] > endurance[v])
        continue;
      double dd = d + adj[v][vv] / speed[v];
      if (dd < dist[src][vv]) {
        dist[src][vv] = dd;
        pq.push(pdi(-dd, vv));
      }
    }
  }
}

int main() {

  ios_base::sync_with_stdio(0);
  cin.tie(0);

  freopen("C-small-attempt0.in", "r", stdin);
  freopen("output.txt", "w", stdout);

  int t, x = 1;
  cin >> t;
  while (t--) {

    cin >> n >> q;
    for (int i = 1; i <= n; i++)
      cin >> endurance[i] >> speed[i];

    for (int i = 1; i <= n; i++) {
      for (int j = 1; j <= n; j++) {
        cin >> adj[i][j];
        if (adj[i][j] == -1)
          adj[i][j] = 1e15;
      }
    }

    for (int k = 1; k <= n; k++)
      for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
          adj[i][j] = min(adj[i][j], adj[i][k] + adj[k][j]);

    for (int i = 1; i <= n; i++)
      dijkstra(i);

    cout << "Case #" << x++ << ":";
    while (q--) {
      int a, b;
      cin >> a >> b;
      cout << fixed << setprecision(7) << " " << dist[a][b];
    }
    cout << endl;
  }

  return 0;
}
